/* Problem URL: https://codeforces.com/problemset/problem/1165/D */

/* what? */
#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    vi check(1e6 + 1);
    for (size_t i = 1; i <= 1e6; i++) {
        check[i] = i;
    }

    check[1] = 0;

    vi primes;

    for (size_t i = 2; i <= 1e6; i++) {
        if (check[i] != i) {
            continue;
        }

        primes.push_back(i);

        for (size_t j = i * 2; j <= 1e6; j += i) {
            check[j] = i;
        }
    }

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        if (n == 1) {
            ll num;
            cin >> num;
            if (check[num] != num) {
                cout << "-1\n";
                continue;
            }
            cout << num * num << '\n';
            continue;
        }

        vl nums(n);
        cin >> nums;
        sortv(nums);

        ll num = nums.back() * nums.front();
        ll ans = num;

        bool pos = true;

        for (auto i : nums) {
            if (num % i != 0) {
                pos = false;
                break;
            }
        }

        if (!pos) {
            cout << "-1\n";
            continue;
        }

        int count = 1;
        for (size_t i = 0; primes[i] * primes[i] * primes[i] <= num; i++) {
            int c = 0;
            while (num % primes[i] == 0) {
                c++;
                num /= primes[i];
            }

            count *= c + 1;
        }

        if (check[num] == num) {
            count *= 2;
        } else if (floor(sqrt(num)) * floor(sqrt(num)) == num && check[sqrt(num)] == floor(sqrt(num))) {
            count *= 3;
        } else if (num != 1) {
            count *= 4;
        }

        cout << (count - 2 == nums.size() ? ans : -1) << '\n';
    }
}
